/**
 * The main application package.
 */
package binpackage;

import javax.swing.*;
import java.awt.Dimension;
import com.jgoodies.looks.LookUtils;
import com.jgoodies.looks.Options;

/**
 * This is the main class. Use it to start the application.
 * @author dennis
 */
public class App {

	/**
	 * This is the main class. Use it to start the application.
	 * 
	 * @param p_strArgs Command line arguments
	 */
	public static void main(String[] p_strArgs) {
		App appInstance = new App();
		
		appInstance.configureUI();
		appInstance.buildUI();
		appInstance.showUI();
	}
	
	/**
	 * This method shows a warning to the user.
	 * @param p_strMessage The warning to be displayed.
	 */
	public static void showWarning(String p_strMessage) {
		JOptionPane.showMessageDialog(Globals.frmMain, p_strMessage, "Warning", JOptionPane.WARNING_MESSAGE);
	}
	
	/**
	 * This sets general SWING settings. The looks library from JGoodies is used
	 * to achieve a more comfortable look and feel and to get rid of the default
	 * blue color scheme of SWING.
	 */
	private void configureUI() {
		UIManager.put(Options.USE_SYSTEM_FONTS_APP_KEY, Boolean.TRUE);
        Options.setDefaultIconSize(new Dimension(18, 18));

        Options.setPopupDropShadowEnabled(true);
        UIManager.put("jgoodies.popupDropShadowEnabled", Boolean.TRUE);
        
        String strLafName =
            LookUtils.IS_OS_WINDOWS_XP
                ? Options.getCrossPlatformLookAndFeelClassName()
                : Options.getSystemLookAndFeelClassName();

        try {
            UIManager.setLookAndFeel(strLafName);
        } catch (Exception e) {
            System.err.println("Can't set look & feel:" + e);
        }
	}

	/**
	 * This creates instances all GUI related classes.
	 */
	private void buildUI() {
		Globals.frmMain = new MainFrame();
	}
	
	/**
	 * This method displays the main frame.
	 */
	private void showUI() {
		Globals.frmMain.pack();
		Globals.frmMain.setDefaultCloseOperation(MainFrame.EXIT_ON_CLOSE);
		Globals.frmMain.setVisible(true);
	}
	
}
