/**
 * 
 */
package binpackage;

import java.util.Collections;
import java.util.LinkedList;
import exceptions.AbortException;
import exceptions.GreedyException;
import exceptions.NoContextException;
//llbins entf�llt dies muss entsprechend ge�ndert werden
/**
 * This is a simple greedy solution finder.
 * @author hafner, version 071228
 */
public final class OneByOneGreedySolver extends AbstractGreedy {

	public static final String strName = "One by one";
	
	private int i_nBins;		                // Amount of bins
	private int i_nElements;	                // Amount of elements

	private LinkedList<Element> ll_elements;	//local LinkedList for all elements
	
	private boolean b_sorted;           // to control if all Elements are already sorted
	private int i_counter;					//to select the element, which has to be inserted
	private int i_usedelements;				//to limit the insertable elements on the amount of elements
	private int i_i;						//incremental variable to go through the elements
	private int i_ilast;					//variable to save the last i_i
	private boolean b_up;					//shows the last opperation, whether -- or ++
	private double[] d_bincap;
	/* (non-Javadoc)
	 * @see binpackage.AbstractGreedy#AbstractGreedy(binpackage.Context)
	 */
	public OneByOneGreedySolver(Context p_cxt) {
		super(p_cxt);
		//Initializing local variables
		this.i_nBins = p_cxt.getAmountBins();			//Get Amount of Bins from the Context p_cxt
		this.i_nElements = p_cxt.getAmountElements();	//Get Amount of Elements from the Context p_cxt
		ll_elements = p_cxt.getElements();	//Save Bins from Context p_cxt in local LinkedList 
		b_sorted = false;
		i_counter = 0;
		i_usedelements = 0;
		i_i = 0;				
		i_ilast = 0;
		//initialize bincap with 0
		d_bincap = new double[i_nBins];
		for(int i=0; i<i_nBins;i++)
			d_bincap[i] = 0;

	}
	
	
	/**
	 * This method makes sure that the list of all elements is sorted in an ascending way. 
	 */
	public void greedysort(){    //Context c
		Collections.sort(ll_elements);			//use the java.utils.Collections sort method
		Collections.reverse(ll_elements);    //cxt.getElements()); reverse the order of all sorted elements
	}
	
	
	/* (non-Javadoc)
	 * @see binpackage.AbstractGreedy#greedyStep()
	 */
	// TODO Replace GreedyException with specific sub-classes of it.
	//      Never throw a GreedyException itself. Always throw a sub-class.
	@Override
	public void greedyStep() throws GreedyException,
	                                AbortException,
	                                NoContextException {
		
		if (this.cxt == null) {			//Stop the greedyStep Method if there is no context available
			throw new NoContextException();
		}
		
		if(b_sorted == false) {	//sorts the LL with elements via the greedysort method
			greedysort(); 		//but only once at the the start oft greedy
			b_sorted = true;	//to decide if the list is already sorted or not
		}
		

		while(i_i<i_nBins && i_i > -1 && i_usedelements <=i_nElements){// && d_bincap[i_i] < 100.0){	heute
				ll_elements.get(i_counter).setBinNr(i_i);					//add binNr to each element
			
			if(i_ilast > 0){		//start with insert with the last bin and go on to the first bin
				i_i--;				//abase the counting variable to navigate through the bins
				b_up = false;		//backup the navigating direction ->reverse
			}
			else if(i_ilast <= 0){	//<=
				i_i++;				//increase the counting variable to navigate through the bins
				b_up = true;		//backup the navigating direction ->forward
			}
			i_counter++;			//counts the next focused element
			i_usedelements++;		//sum of already inserted elements
			if(i_usedelements ==i_nElements)		//100 % der elemente einsortiert -> fertig
				throw new AbortException();
		}
		i_ilast = i_i;		//saves the last bin to which an element was added
		//speichere letzten durchgehwert zwischen, f�r ueberpruefung, ob
		//aufwaerts oder abwaerts gez�hlt werden muss, bei naechstem durchlauf
		if(b_up ==true)				//after having navigated forward through the bins
			i_i = i_nBins -1;		//set the incremental variable to the correct start value
		else if (b_up == false)		//after having navigated forward through the bins 
			i_i = i_i +1;			//set the incremental variable to the correct start value
		
	//Exception und Abbruchbedingung f�r jeden step einf�gen?!?!??!
		
		// TODO Check abort condition here, then
		//if(i_usedelements ==i_nElements || d_bincap[i_i] < 100.0)		//100 % der elemente ueberschritten dann auch ausl�sen
//		if(i_usedelements ==i_nElements)		//100 % der elemente ueberschritten dann auch ausl�sen
//			throw new AbortException();
		// if a final solution has been found. 
		
		// TODO Perform one greedy step.
	}
	
}
