/**
 * 
 */
package binpackage;

import java.lang.reflect.Constructor;

/**
 * This class describes a ProblemWorker. It's used by the ProblemWorkerController.
 * @author dennis
 */
public class ProblemWorkerDescription {

	private String strName;
	private String strClassPath;
	private Class<?> clClass;
	private Constructor<?> csConstructor;
	private ProblemWorkerType pwtType;
	
	/**
	 * Default constructor
	 * @param p_strName Canonical name of the ProblemWorker
	 * @param p_strClassPath Absolute class path as used by Java Reflection
	 * @param p_clClass Class object of the ProblemWorker
	 * @param p_csConstructor Constructor(Context) object of the ProblemWorker
	 */
	public ProblemWorkerDescription(String p_strName, ProblemWorkerType p_pwtType, String p_strClassPath, Class<?> p_clClass, Constructor<?> p_csConstructor) {
		super();
		
		this.strName = p_strName;
		this.strClassPath = p_strClassPath;
		this.clClass = p_clClass;
		this.csConstructor = p_csConstructor;
		this.pwtType = p_pwtType;
	}

	/**
	 * @return the canonical name of the ProblemWorker
	 */
	public String getName() {
		return strName;
	}

	/**
	 * @param p_strName The canonical name to set
	 */
	public void setName(String p_strName) {
		this.strName = p_strName;
	}

	/**
	 * @return the absolute class path as used by Java Reflection
	 */
	public String getClassPath() {
		return strClassPath;
	}

	/**
	 * @param p_strClassPath the absolute class path as used by Java Reflection
	 */
	public void setClassPath(String p_strClassPath) {
		this.strClassPath = p_strClassPath;
	}

	/**
	 * @return the class object of the ProblemWorker
	 */
	public Class<?> getClassObject() {
		return clClass;
	}

	/**
	 * @param p_clClass Set the class object of the ProblemWorker
	 */
	public void setClassObject(Class<?> p_clClass) {
		this.clClass = p_clClass;
	}

	/**
	 * @return the Constructor object of the ProblemWorker. This constructor takes
	 *         exactly on Context object as a parameter.
	 */
	public Constructor<?> getConstructor() {
		return csConstructor;
	}

	/**
	 * @param p_csConstructor Set the constructor object of the ProblemWorker 
	 */
	public void setConstructor(Constructor<?> p_csConstructor) {
		this.csConstructor = p_csConstructor;
	}

	/**
	 * @return the type of the ProblemWorker
	 */
	public ProblemWorkerType getType() {
		return pwtType;
	}

	/**
	 * @param p_pwtType Set the type of the ProblemWorker
	 */
	public void setType(ProblemWorkerType p_pwtType) {
		this.pwtType = p_pwtType;
	}
}
